export interface AuditResult<A, B> {
    name: string;
    category: string;
    violation: boolean;
    rawValue: A;
    optimalValue: A;
    extendedInfo: B[];
}
export declare abstract class Audit<A, B> {
    private container;
    protected artifacts: Map<string, any>;
    constructor(artifacts: Map<string, any>);
    abstract name: string;
    abstract category: string;
    abstract rawValue: A;
    abstract optimalValue: A;
    abstract validate(): boolean;
    run(): Promise<void>;
    add(record: B): Promise<void>;
    collect(): Promise<AuditResult<A, B>>;
    size(): Promise<number>;
}
