"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Native.
var events_1 = require("events");
// Package.
var _ = require("lodash");
var debug = require("debug");
var fs = require("fs-extra");
var Output_1 = require("./Output");
var Runner_1 = require("./Runner");
var Target_1 = require("./Target");
// Code.
var debugVerbose = debug('di:verbose:browser');
var debugWarn = debug('di:warn:browser');
var EBrowserEvents;
(function (EBrowserEvents) {
    EBrowserEvents["Disconnected"] = "disconnected";
    EBrowserEvents["TargetCreated"] = "targetcreated";
    EBrowserEvents["TargetDestroyed"] = "targetdestroyed";
    EBrowserEvents["TargetInfoChanged"] = "targetinfochanged";
})(EBrowserEvents = exports.EBrowserEvents || (exports.EBrowserEvents = {}));
var Browser = /** @class */ (function (_super) {
    __extends(Browser, _super);
    function Browser(connection, params, closeCallback, userDataDir) {
        var _this = _super.call(this) || this;
        _this.pendingRunners = new Set();
        _this.runnerResults = [];
        _this.targets = new Map();
        _this.targetsHistory = new Set();
        _this.depth = 0;
        _this.closeCallback = closeCallback;
        _this.connection = connection;
        _this.params = params;
        _this.userDataDir = userDataDir;
        debugVerbose("params %j", _this.params);
        _this.connection.setClosedCallback(function () {
            _this.emit(EBrowserEvents.Disconnected);
        });
        _this.connection.on('Target.targetCreated', _this.targetCreated.bind(_this));
        _this.connection.on('Target.targetDestroyed', _this.targetDestroyed.bind(_this));
        _this.connection.on('Target.targetInfoChanged', _this.targetInfoChanged.bind(_this));
        return _this;
    }
    Browser.create = function (connection, params, closeCallback, userDataDir) {
        return __awaiter(this, void 0, void 0, function () {
            var browser, setDiscoverTargetsParams;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debugVerbose("create");
                        browser = new Browser(connection, params, closeCallback, userDataDir);
                        setDiscoverTargetsParams = {
                            discover: true,
                        };
                        return [4 /*yield*/, connection.send('Target.setDiscoverTargets', setDiscoverTargetsParams)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, browser];
                }
            });
        });
    };
    Browser.prototype.createTarget = function () {
        return __awaiter(this, void 0, void 0, function () {
            var params, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = {
                            url: 'about:blank',
                        };
                        debugVerbose("createTarget params: %j", params);
                        return [4 /*yield*/, this.connection.send('Target.createTarget', params)];
                    case 1:
                        response = _a.sent();
                        debugVerbose("createTarget response: %j", response);
                        return [2 /*return*/, response];
                }
            });
        });
    };
    Browser.prototype.targetCreated = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            var target, page, runner;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debugVerbose("targetCreated event: %j", event);
                        return [4 /*yield*/, this.updateTargetsHistory(event.targetInfo, 'created')];
                    case 1:
                        _a.sent();
                        target = new Target_1.default(this, event.targetInfo);
                        this.targets.set(event.targetInfo.targetId, target);
                        return [4 /*yield*/, target.initializedPromise];
                    case 2:
                        if (_a.sent()) {
                            debugVerbose("initialized targetId: " + event.targetInfo.targetId);
                            this.emit(EBrowserEvents.TargetCreated, target);
                        }
                        if (!(this.isAnalysing && event.targetInfo.type === 'page')) return [3 /*break*/, 7];
                        debugVerbose("new analyse targetId: " + event.targetInfo.targetId);
                        return [4 /*yield*/, target.page()];
                    case 3:
                        page = _a.sent();
                        if (!page) return [3 /*break*/, 5];
                        ++this.depth;
                        runner = new Runner_1.default(event.targetInfo.targetId, this.updateTargetsHistory.bind(this), page, this.params, this.runnerResultCallback.bind(this), this.depth);
                        this.pendingRunners.add(event.targetInfo.targetId);
                        debugVerbose("added new pending runner queue size: " + this.pendingRunners.size);
                        return [4 /*yield*/, runner.run()];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 5:
                        debugWarn("Failed to create a new page");
                        _a.label = 6;
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        debugVerbose("skip analyse targetId: " + event.targetInfo.targetId);
                        _a.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    Browser.prototype.targetDestroyed = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            var target;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debugVerbose("targetDestroyed event: %j", event);
                        target = this.targets.get(event.targetId);
                        if (!target) return [3 /*break*/, 2];
                        target.initializedCallback(false);
                        this.targets.delete(event.targetId);
                        return [4 /*yield*/, target.initializedPromise];
                    case 1:
                        if (_a.sent()) {
                            this.emit(EBrowserEvents.TargetDestroyed, target);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        debugWarn("Target " + event.targetId + " not found");
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Browser.prototype.targetInfoChanged = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            var target;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debugVerbose("targetInfoChanged event: %j", event);
                        return [4 /*yield*/, this.updateTargetsHistory(event.targetInfo, 'updated')];
                    case 1:
                        _a.sent();
                        target = this.targets.get(event.targetInfo.targetId);
                        if (target) {
                            target.updateTargetInfo(event.targetInfo, this.targetsHistory.size);
                        }
                        else {
                            debugWarn("Target " + event.targetInfo.targetId + " not found");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Browser.prototype.runnerResultCallback = function (report) {
        this.runnerResults.push(report);
        this.pendingRunners.delete(report.targetId);
        if (this.pendingRunners.size === 0) {
            debugVerbose("pending runner queue size: 0");
            if (this.pendingRunnersCallback) {
                this.pendingRunnersCallback();
            }
            else {
                debugWarn("pendingRunnersCallback not set");
            }
        }
    };
    Browser.prototype.analyse = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var initialTargets, initialEmtpy, initialEmtpyId, targetId, target, pendingRunnersClear, page, runner, targets, targetsHistory;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debugVerbose("analyse url: " + url);
                        return [4 /*yield*/, this.getTargets()];
                    case 1:
                        initialTargets = _a.sent();
                        initialEmtpy = initialTargets.filter(function (n) { return n.targetInfo.type === 'page'; })[0];
                        initialEmtpyId = _.get(initialEmtpy, 'targetInfo.targetId');
                        return [4 /*yield*/, this.createTarget()];
                    case 2:
                        targetId = (_a.sent()).targetId;
                        return [4 /*yield*/, this.targets.get(targetId)];
                    case 3:
                        target = _a.sent();
                        pendingRunnersClear = new Promise(function (fulfill) { return (_this.pendingRunnersCallback = fulfill); }).then(function () { return null; });
                        if (!target) return [3 /*break*/, 8];
                        return [4 /*yield*/, target.page()];
                    case 4:
                        page = _a.sent();
                        this.isAnalysing = true;
                        debugVerbose("isAnalysing: true");
                        if (!page) return [3 /*break*/, 6];
                        runner = new Runner_1.default(targetId, this.updateTargetsHistory.bind(this), page, this.params, this.runnerResultCallback.bind(this), this.depth, url);
                        this.pendingRunners.add(targetId);
                        return [4 /*yield*/, runner.run()];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 6:
                        debugWarn("Can not create a new page.");
                        _a.label = 7;
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        debugWarn("Target " + targetId + " not found");
                        _a.label = 9;
                    case 9: return [4 /*yield*/, pendingRunnersClear];
                    case 10:
                        _a.sent();
                        return [4 /*yield*/, this.getTargets()];
                    case 11:
                        targets = _a.sent();
                        return [4 /*yield*/, this.getTargetsHistory()];
                    case 12:
                        targetsHistory = _a.sent();
                        return [4 /*yield*/, Output_1.default.generateResult(targets
                                .filter(function (n) { return n.targetInfo.targetId !== initialEmtpyId; })
                                .filter(function (n) { return n.targetInfo.type === 'page'; }), targetsHistory
                                .filter(function (n) { return n.targetId !== initialEmtpyId; })
                                .filter(function (n) { return n.type === 'page'; }), this.runnerResults)];
                    case 13: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Browser.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debugVerbose("close");
                        this.connection.dispose();
                        return [4 /*yield*/, fs.remove(this.userDataDir)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.closeCallback.call(null)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Browser.prototype.getTargets = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Array.from(this.targets.values()).filter(function (target) { return target.isInitialized; })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Browser.prototype.getTargetsHistory = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Array.from(this.targetsHistory.values())];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Browser.prototype.updateTargetsHistory = function (targetInfo, reason) {
        var version = this.targetsHistory.size + 1;
        this.targetsHistory.add(__assign({}, targetInfo, { reason: reason,
            version: version, ts: new Date().toJSON() }));
    };
    return Browser;
}(events_1.EventEmitter));
exports.Browser = Browser;
