/// <reference types="node" />
/// <reference types="ws" />
import { EventEmitter } from 'events';
import * as WebSocket from 'ws';
import Session from './Session';
export declare class Connection extends EventEmitter {
    private callbacks;
    private delay;
    private lastId;
    private sessions;
    private url;
    private ws;
    static create(url: string, delay: number): Promise<Connection>;
    constructor(url: string, ws: WebSocket, delay: number);
    private onClose(code?, message?);
    private onMessage(message);
    createSession(targetId: string): Promise<Session>;
    dispose(): void;
    send<T>(method: string, params?: {
        [key: string]: any;
    }): Promise<T>;
    private closeCallback?;
    setClosedCallback(callback: () => void): void;
}
