"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Native.
var events_1 = require("events");
// Package.
var debug = require("debug");
var WebSocket = require("ws");
var error = require("../utils/error");
var Session_1 = require("./Session");
// Code.
var debugError = debug('di:error:connection');
var debugVerbose = debug('di:verbose:connection');
var debugSilly = debug('di:silly:connection');
var Connection = /** @class */ (function (_super) {
    __extends(Connection, _super);
    function Connection(url, ws, delay) {
        var _this = _super.call(this) || this;
        _this.callbacks = new Map();
        _this.delay = 0;
        _this.lastId = 0;
        _this.sessions = new Map();
        _this.url = url;
        _this.ws = ws;
        _this.delay = delay;
        _this.ws.on('message', _this.onMessage.bind(_this));
        _this.ws.on('close', _this.onClose.bind(_this));
        _this.ws.on('error', function () { return debugError("ws error event fired"); });
        return _this;
    }
    Connection.create = function (url, delay) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                debugVerbose("create: %j", { url: url, delay: delay });
                return [2 /*return*/, new Promise(function (resolve, _reject) {
                        var ws = new WebSocket(url, { perMessageDeflate: false });
                        ws.on('open', function () {
                            var connection = new Connection(url, ws, delay);
                            return resolve(connection);
                        });
                        ws.on('error', function () {
                            // return reject
                            debugError("ws error event fired");
                        });
                    })];
            });
        });
    };
    Connection.prototype.onClose = function (code, message) {
        debugVerbose("onClose: code: " + code + " message: " + message);
        // TODO: handle this edge case in a better way.
        // Toggle off `code: 1006`.
        // https://stackoverflow.com/questions/19304157/getting-the-reason-why-websockets-closed-with-close-code-1006
        // https://github.com/websockets/ws/issues/799
        // It might be 1005 now if switch to v4
        if (code && code === 1006) {
            return;
        }
        if (this.closeCallback) {
            this.closeCallback();
            this.closeCallback = undefined;
        }
        this.ws.removeAllListeners();
        this.callbacks.forEach(function (callback) {
            callback.reject(new error.ProtocolError("Connection (" + callback.method + "): Target closed"));
        });
        this.callbacks.clear();
        this.sessions.forEach(function (session) {
            session.onClosed();
        });
        this.sessions.clear();
    };
    Connection.prototype.onMessage = function (message) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var object, callback, session, session;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.delay) return [3 /*break*/, 2];
                        return [4 /*yield*/, new Promise(function (f) { return setTimeout(f, _this.delay); })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        debugSilly("\u25C0 RECV " + message);
                        object = JSON.parse(message);
                        if (object.id && this.callbacks.has(object.id)) {
                            callback = this.callbacks.get(object.id);
                            this.callbacks.delete(object.id);
                            if (callback) {
                                if (object.error) {
                                    callback.reject(new error.ProtocolError("Connection (" + callback.method + "): " + object.error.message + " " + object
                                        .error.data));
                                }
                                else {
                                    callback.resolve(object.result);
                                }
                            }
                        }
                        else {
                            if (object.id) {
                                new error.ProtocolError("Connection: Unexpected message not handled bby a callback.");
                            }
                            if (object.method === 'Target.receivedMessageFromTarget') {
                                session = this.sessions.get(object.params.sessionId);
                                if (session)
                                    session.onMessage(object.params.message);
                            }
                            else if (object.method === 'Target.detachedFromTarget') {
                                debugVerbose("Target detached");
                                session = this.sessions.get(object.params.sessionId);
                                if (session) {
                                    session.onClosed();
                                }
                                this.sessions.delete(object.params.sessionId);
                            }
                            else {
                                this.emit(object.method, object.params);
                            }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Connection.prototype.createSession = function (targetId) {
        return __awaiter(this, void 0, void 0, function () {
            var params, response, session;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = { targetId: targetId };
                        debugVerbose("createSession params: %j", params);
                        return [4 /*yield*/, this.send('Target.attachToTarget', params)];
                    case 1:
                        response = _a.sent();
                        debugVerbose("attachToTarget response: %j", response);
                        session = new Session_1.default(this, targetId, response.sessionId);
                        debugVerbose("createSession result: %j", {
                            sessionId: session.sessionId,
                            targetId: session.targetId,
                        });
                        this.sessions.set(response.sessionId, session);
                        return [2 /*return*/, session];
                }
            });
        });
    };
    Connection.prototype.dispose = function () {
        debugVerbose("Dispose connection");
        this.onClose();
        try {
            this.ws.on('error', function () { return debugError("ws error event fired on close"); });
            this.ws.close();
        }
        catch (err) {
            debugError(err);
        }
    };
    Connection.prototype.send = function (method, params) {
        var _this = this;
        var id = ++this.lastId;
        var message = JSON.stringify({ id: id, method: method, params: params });
        debugSilly("SEND \u25BA " + message);
        this.ws.send(message);
        return new Promise(function (resolve, reject) {
            return _this.callbacks.set(id, {
                resolve: resolve,
                reject: reject,
                method: method,
            });
        });
    };
    Connection.prototype.setClosedCallback = function (callback) {
        this.closeCallback = callback;
    };
    return Connection;
}(events_1.EventEmitter));
exports.Connection = Connection;
