import { TracerMessage } from './Tracer';
export interface DevtoolLogRecord {
    method: string;
    params: any;
}
export default class DevtoolLogManager {
    private filter;
    private isRecording;
    private records;
    private traceSpan;
    private traceTargetId;
    private traceTargetVersion;
    constructor(filter?: RegExp);
    setEvent(message: TracerMessage): void;
    setTargetId(id: string): void;
    setTargetVersion(version: number): void;
    beginRecording(): void;
    endRecording(): void;
    getRecords(): DevtoolLogRecord[];
    record(record: DevtoolLogRecord): void;
    reset(): void;
}
