"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DevtoolLogManager = /** @class */ (function () {
    function DevtoolLogManager(filter) {
        this.isRecording = false;
        this.traceSpan = 'noop';
        this.traceTargetId = 'noop';
        this.traceTargetVersion = 1;
        this.filter = filter;
    }
    DevtoolLogManager.prototype.setEvent = function (message) {
        this.traceSpan = message.event;
    };
    DevtoolLogManager.prototype.setTargetId = function (id) {
        this.traceTargetId = id;
    };
    DevtoolLogManager.prototype.setTargetVersion = function (version) {
        this.traceTargetVersion = version;
    };
    DevtoolLogManager.prototype.beginRecording = function () {
        this.isRecording = true;
    };
    DevtoolLogManager.prototype.endRecording = function () {
        this.isRecording = false;
    };
    DevtoolLogManager.prototype.getRecords = function () {
        return this.records;
    };
    DevtoolLogManager.prototype.record = function (record) {
        if (this.isRecording && (!this.filter || this.filter.test(record.method))) {
            record.params.span = this.traceSpan;
            record.params.targetId = this.traceTargetId;
            record.params.targetVersion = this.traceTargetVersion;
            this.records.push(record);
        }
    };
    DevtoolLogManager.prototype.reset = function () {
        this.records = [];
    };
    return DevtoolLogManager;
}());
exports.default = DevtoolLogManager;
