"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Code.
var Element = /** @class */ (function () {
    function Element(element, page) {
        this.page = page;
        this.element = element;
    }
    Element.prototype.getAttibutes = function () {
        return this.page
            .send('DOM.getAttributes', {
            nodeId: this.element.nodeId,
        })
            .then(function (response) {
            if (response) {
                return response.attributes;
            }
            return null;
        });
    };
    Element.prototype.getAttribute = function (name) {
        return this.page
            .send('DOM.getAttributes', {
            nodeId: this.element.nodeId,
        })
            .then(function (response) {
            if (response) {
                var attributeIndex = response.attributes.indexOf(name);
                if (attributeIndex === -1) {
                    return null;
                }
                return response.attributes[attributeIndex + 1];
            }
            return null;
        });
    };
    Element.prototype.getProperty = function (name) {
        var _this = this;
        return this.page
            .send('DOM.resolveNode', {
            nodeId: this.element.nodeId,
        })
            .then(function (response) {
            return _this.page.getObjectProperty(response.object.objectId, name);
        });
    };
    Element.prototype.resolveNode = function () {
        return this.page
            .send('DOM.resolveNode', {
            nodeId: this.element.nodeId,
        })
            .then(function (response) {
            return response.object;
        });
    };
    return Element;
}());
exports.default = Element;
