import * as Protocol from '../types/tot';
import JsHandle from './JsHandle';
import ElementHandle from './ElementHandle';
import Session from './Session';
export declare type ObjectHandle = JsHandle | ElementHandle;
export declare type ObjectHandleFactory = (remoteObject: Protocol.Runtime.RemoteObject) => ObjectHandle;
export default class ExecutionContext {
    private client;
    contextId: number;
    objectHandleFactory: ObjectHandleFactory;
    frameId?: string;
    isDefault: boolean;
    constructor(client: Session, contextPayload: Protocol.Runtime.ExecutionContextDescription, objectHandleFactory: ObjectHandleFactory);
    evaluate(pageFunction: string | ((...args: any[]) => any), ...args: any[]): Promise<any>;
    evaluateHandle(pageFunction: string | ((...args: any[]) => any), ...args: any[]): Promise<ObjectHandle | undefined>;
    queryObjects(objectHandle: ObjectHandle): Promise<ObjectHandle>;
}
