import * as Protocol from '../types/tot';
import ExecutionContext from './ExecutionContext';
import Page from './Page';
import Session from './Session';
import WaitTask from './WaitTask';
export default class Frame {
    private childFrames;
    private client;
    private contextPromise?;
    private contextResolveCallback?;
    private detached;
    private page;
    private parentFrame;
    private waitTasks;
    id: string;
    name: string;
    url: string;
    loaderId: string;
    lifecycleEvents: Set<string>;
    constructor(client: Session, page: Page, parentFrame: Frame | null, id: string);
    setDefaultContext(context?: ExecutionContext): void;
    executionContext(): Promise<ExecutionContext> | undefined;
    evaluate(pageFunction: string | ((...args: any[]) => any), ...args: any[]): Promise<any>;
    content(): Promise<string>;
    setContent(html: string): Promise<void>;
    text(): Promise<string>;
    navigated(framePayload: Protocol.Page.Frame): void;
    detach(): void;
    getChildFrames(): Frame[];
    addWaitTask(waitTask: WaitTask): void;
    getWaitTask(): Set<WaitTask>;
    removeWaitTask(waitTask: WaitTask): void;
    isDetached(): boolean;
    onLifecycleEvent(loaderId: string, name: string): void;
}
