/// <reference types="node" />
import { EventEmitter } from 'events';
import * as Protocol from '../types/tot';
import Page from './Page';
import Session from './Session';
import Frame from './Frame';
import JSHandle from './JsHandle';
export default class FrameManager extends EventEmitter {
    private client;
    private contextIdToContext;
    private page;
    private frames;
    mainFrame?: Frame;
    constructor(client: Session, frameTree: Protocol.Page.FrameTree, page: Page);
    static readonly Events: {
        FrameAttached: string;
        FrameNavigated: string;
        FrameDetached: string;
        LifecycleEvent: string;
    };
    private handleFrameTree(frameTree);
    private removeContext(context);
    private onLifecycleEvent(event);
    private onExecutionContextCreated(contextPayload);
    private onExecutionContextDestroyed(executionContextId);
    private onExecutionContextsCleared();
    private onFrameAttached(frameId, parentFrameId);
    private onFrameNavigated(framePayload);
    private onFrameDetached(frameId);
    private removeFramesRecursively(frame);
    createJSHandle(contextId: number, remoteObject: Protocol.Runtime.RemoteObject): JSHandle;
}
