import Page from './Page';
import { ETracerEvent } from './Tracer';
export interface GathererResult<A> {
    name: string;
    container: A[];
}
export declare abstract class Gatherer<A> {
    private container;
    protected page: Page;
    protected span: ETracerEvent | string;
    constructor(page: Page);
    abstract name: string;
    prepare(): Promise<void>;
    run(): Promise<void>;
    dispose(): Promise<void>;
    add(record: A): Promise<void>;
    collect(): Promise<GathererResult<A>>;
    size(): number;
}
