import Session from './Session';
export declare class Keyboard {
    private client;
    private modifiers;
    private pressedKeys;
    constructor(client: Session);
    private modifierBit(key);
    down(key: string, options?: {
        text: string;
    }): Promise<void>;
    up(key: string): Promise<void>;
    sendCharacter(char: string): Promise<void>;
    type(text: string, options: {
        delay: number | undefined;
    }): Promise<void>;
    press(key: string, options: any): Promise<void>;
    getModifiers(): number;
}
export declare class Mouse {
    private button;
    private client;
    private keyboard;
    private x;
    private y;
    constructor(client: Session, keyboard: Keyboard);
    move(x: number, y: number, options?: any): Promise<void>;
    click(x: number, y: number, options?: any): Promise<void>;
    down(options?: any): Promise<void>;
    up(options?: any): Promise<void>;
}
export declare class Touchscreen {
    private client;
    private keyboard;
    constructor(client: Session, keyboard: Keyboard);
    tap(x: number, y: number): Promise<void>;
}
