"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Code.
var Keyboard = /** @class */ (function () {
    function Keyboard(client) {
        this.modifiers = 0;
        this.pressedKeys = new Set();
        this.client = client;
    }
    Keyboard.prototype.modifierBit = function (key) {
        if (key === 'Alt')
            return 1;
        if (key === 'Control')
            return 2;
        if (key === 'Meta')
            return 4;
        if (key === 'Shift')
            return 8;
        return 0;
    };
    Keyboard.prototype.down = function (key, options) {
        if (options === void 0) { options = { text: '' }; }
        return __awaiter(this, void 0, void 0, function () {
            var text, autoRepeat;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        text = options.text;
                        autoRepeat = this.pressedKeys.has(key);
                        this.pressedKeys.add(key);
                        this.modifiers |= this.modifierBit(key);
                        return [4 /*yield*/, this.client.send('Input.dispatchKeyEvent', {
                                type: text ? 'keyDown' : 'rawKeyDown',
                                modifiers: this.modifiers,
                                windowsVirtualKeyCode: keyCodeForKey(key),
                                code: codeForKey(key),
                                key: key,
                                text: text,
                                unmodifiedText: text,
                                autoRepeat: autoRepeat,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Keyboard.prototype.up = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.modifiers &= ~this.modifierBit(key);
                        this.pressedKeys.delete(key);
                        return [4 /*yield*/, this.client.send('Input.dispatchKeyEvent', {
                                type: 'keyUp',
                                modifiers: this.modifiers,
                                key: key,
                                windowsVirtualKeyCode: keyCodeForKey(key),
                                code: codeForKey(key),
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Keyboard.prototype.sendCharacter = function (char) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.send('Input.dispatchKeyEvent', {
                            type: 'char',
                            modifiers: this.modifiers,
                            text: char,
                            key: char,
                            unmodifiedText: char,
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Keyboard.prototype.type = function (text, options) {
        return __awaiter(this, void 0, void 0, function () {
            var delay, _i, text_1, char;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        delay = 0;
                        if (options && options.delay)
                            delay = options.delay;
                        _i = 0, text_1 = text;
                        _a.label = 1;
                    case 1:
                        if (!(_i < text_1.length)) return [3 /*break*/, 5];
                        char = text_1[_i];
                        return [4 /*yield*/, this.press(char, { text: char, delay: delay })];
                    case 2:
                        _a.sent();
                        if (!delay) return [3 /*break*/, 4];
                        return [4 /*yield*/, new Promise(function (f) { return setTimeout(f, delay); })];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    Keyboard.prototype.press = function (key, options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.down(key, options)];
                    case 1:
                        _a.sent();
                        if (!(options && options.delay)) return [3 /*break*/, 3];
                        return [4 /*yield*/, new Promise(function (f) { return setTimeout(f, options.delay); })];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [4 /*yield*/, this.up(key)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Keyboard.prototype.getModifiers = function () {
        return this.modifiers;
    };
    return Keyboard;
}());
exports.Keyboard = Keyboard;
var Mouse = /** @class */ (function () {
    function Mouse(client, keyboard) {
        this.button = 'none';
        this.x = 0;
        this.y = 0;
        this.client = client;
        this.keyboard = keyboard;
    }
    Mouse.prototype.move = function (x, y, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var fromX, fromY, steps, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fromX = this.x;
                        fromY = this.y;
                        this.x = x;
                        this.y = y;
                        steps = options.steps || 1;
                        i = 1;
                        _a.label = 1;
                    case 1:
                        if (!(i <= steps)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.client.send('Input.dispatchMouseEvent', {
                                type: 'mouseMoved',
                                button: this.button,
                                x: fromX + (this.x - fromX) * (i / steps),
                                y: fromY + (this.y - fromY) * (i / steps),
                                modifiers: this.keyboard.getModifiers(),
                            })];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Mouse.prototype.click = function (x, y, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.move(x, y)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.down(options)];
                    case 2:
                        _a.sent();
                        if (!(typeof options.delay === 'number')) return [3 /*break*/, 4];
                        return [4 /*yield*/, new Promise(function (f) { return setTimeout(f, options.delay); })];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [4 /*yield*/, this.up(options)];
                    case 5:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Mouse.prototype.down = function (options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.button = options.button || 'left';
                        return [4 /*yield*/, this.client.send('Input.dispatchMouseEvent', {
                                type: 'mousePressed',
                                button: this.button,
                                x: this.x,
                                y: this.y,
                                modifiers: this.keyboard.getModifiers(),
                                clickCount: options.clickCount || 1,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Mouse.prototype.up = function (options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.button = 'none';
                        return [4 /*yield*/, this.client.send('Input.dispatchMouseEvent', {
                                type: 'mouseReleased',
                                button: options.button || 'left',
                                x: this.x,
                                y: this.y,
                                modifiers: this.keyboard.getModifiers(),
                                clickCount: options.clickCount || 1,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return Mouse;
}());
exports.Mouse = Mouse;
var Touchscreen = /** @class */ (function () {
    function Touchscreen(client, keyboard) {
        this.client = client;
        this.keyboard = keyboard;
    }
    Touchscreen.prototype.tap = function (x, y) {
        return __awaiter(this, void 0, void 0, function () {
            var touchPoints;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // Touches appear to be lost during the first frame after navigation.
                    // This waits a frame before sending the tap.
                    // @see https://crbug.com/613219
                    return [4 /*yield*/, this.client.send('Runtime.evaluate', {
                            expression: 'new Promise(x => requestAnimationFrame(() => requestAnimationFrame(x)))',
                            awaitPromise: true,
                        })];
                    case 1:
                        // Touches appear to be lost during the first frame after navigation.
                        // This waits a frame before sending the tap.
                        // @see https://crbug.com/613219
                        _a.sent();
                        touchPoints = [{ x: Math.round(x), y: Math.round(y) }];
                        return [4 /*yield*/, this.client.send('Input.dispatchTouchEvent', {
                                type: 'touchStart',
                                touchPoints: touchPoints,
                                modifiers: this.keyboard.getModifiers(),
                            })];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.client.send('Input.dispatchTouchEvent', {
                                type: 'touchEnd',
                                touchPoints: [],
                                modifiers: this.keyboard.getModifiers(),
                            })];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return Touchscreen;
}());
exports.Touchscreen = Touchscreen;
var keys = {
    Cancel: { keyCode: 3, code: 'Abort' },
    Help: { keyCode: 6, code: 'Help' },
    Backspace: { keyCode: 8, code: 'Backspace' },
    Tab: { keyCode: 9, code: 'Tab' },
    Clear: { keyCode: 12, code: '' },
    Enter: { keyCode: 13, code: 'Enter' },
    Shift: { keyCode: 16, code: 'ShiftLeft' },
    Control: { keyCode: 17, code: 'ControlLeft' },
    Alt: { keyCode: 18, code: 'AltLeft' },
    Pause: { keyCode: 19, code: 'Pause' },
    CapsLock: { keyCode: 20, code: 'CapsLock' },
    Escape: { keyCode: 27, code: 'Escape' },
    Convert: { keyCode: 28, code: 'Convert' },
    NonConvert: { keyCode: 29, code: 'NonConvert' },
    Accept: { keyCode: 30, code: '' },
    ModeChange: { keyCode: 31, code: '' },
    PageUp: { keyCode: 33, code: 'PageUp' },
    PageDown: { keyCode: 34, code: 'PageDown' },
    End: { keyCode: 35, code: 'End' },
    Home: { keyCode: 36, code: 'Home' },
    ArrowLeft: { keyCode: 37, code: 'ArrowLeft' },
    ArrowUp: { keyCode: 38, code: 'ArrowUp' },
    ArrowRight: { keyCode: 39, code: 'ArrowRight' },
    ArrowDown: { keyCode: 40, code: 'ArrowDown' },
    Select: { keyCode: 41, code: 'Select' },
    Print: { keyCode: 42, code: '' },
    Execute: { keyCode: 43, code: 'Open' },
    PrintScreen: { keyCode: 44, code: 'PrintScreen' },
    Insert: { keyCode: 45, code: 'Insert' },
    Delete: { keyCode: 46, code: 'Delete' },
    ')': { keyCode: 48, code: 'Digit0' },
    '!': { keyCode: 49, code: 'Digit1' },
    '@': { keyCode: 50, code: 'Digit2' },
    '#': { keyCode: 51, code: 'Digit3' },
    $: { keyCode: 52, code: 'Digit4' },
    '%': { keyCode: 53, code: 'Digit5' },
    '^': { keyCode: 54, code: 'Digit6' },
    '&': { keyCode: 55, code: 'Digit7' },
    '*': { keyCode: 56, code: 'Digit8' },
    '(': { keyCode: 57, code: 'Digit9' },
    Meta: { keyCode: 91, code: 'MetaLeft' },
    ContextMenu: { keyCode: 93, code: 'ContextMenu' },
    F1: { keyCode: 112, code: 'F1' },
    F2: { keyCode: 113, code: 'F2' },
    F3: { keyCode: 114, code: 'F3' },
    F4: { keyCode: 115, code: 'F4' },
    F5: { keyCode: 116, code: 'F5' },
    F6: { keyCode: 117, code: 'F6' },
    F7: { keyCode: 118, code: 'F7' },
    F8: { keyCode: 119, code: 'F8' },
    F9: { keyCode: 120, code: 'F9' },
    F10: { keyCode: 121, code: 'F10' },
    F11: { keyCode: 122, code: 'F11' },
    F12: { keyCode: 123, code: 'F12' },
    F13: { keyCode: 124, code: 'F13' },
    F14: { keyCode: 125, code: 'F14' },
    F15: { keyCode: 126, code: 'F15' },
    F16: { keyCode: 127, code: 'F16' },
    F17: { keyCode: 128, code: 'F17' },
    F18: { keyCode: 129, code: 'F18' },
    F19: { keyCode: 130, code: 'F19' },
    F20: { keyCode: 131, code: 'F20' },
    F21: { keyCode: 132, code: 'F21' },
    F22: { keyCode: 133, code: 'F22' },
    F23: { keyCode: 134, code: 'F23' },
    F24: { keyCode: 135, code: 'F24' },
    NumLock: { keyCode: 144, code: 'NumLock' },
    ScrollLock: { keyCode: 145, code: 'ScrollLock' },
    AudioVolumeMute: { keyCode: 173, code: 'AudioVolumeMute' },
    AudioVolumeDown: { keyCode: 174, code: 'AudioVolumeDown' },
    AudioVolumeUp: { keyCode: 175, code: 'AudioVolumeUp' },
    MediaTrackNext: { keyCode: 176, code: 'MediaTrackNext' },
    MediaTrackPrevious: { keyCode: 177, code: 'MediaTrackPrevious' },
    MediaStop: { keyCode: 178, code: 'MediaStop' },
    MediaPlayPause: { keyCode: 179, code: 'MediaPlayPause' },
    ';': { keyCode: 186, code: 'Semicolon' },
    ':': { keyCode: 186, code: 'Semicolon' },
    '=': { keyCode: 187, code: 'Equal' },
    '+': { keyCode: 187, code: 'Equal' },
    ',': { keyCode: 188, code: 'Comma' },
    '<': { keyCode: 188, code: 'Comma' },
    '-': { keyCode: 189, code: 'Minus' },
    _: { keyCode: 189, code: 'Minus' },
    '.': { keyCode: 190, code: 'Period' },
    '>': { keyCode: 190, code: 'Period' },
    '/': { keyCode: 191, code: 'Slash' },
    '?': { keyCode: 191, code: 'Slash' },
    '`': { keyCode: 192, code: 'Backquote' },
    '~': { keyCode: 192, code: 'Backquote' },
    '[': { keyCode: 219, code: 'BracketLeft' },
    '{': { keyCode: 219, code: 'BracketLeft' },
    '\\': { keyCode: 220, code: 'Backslash' },
    '|': { keyCode: 220, code: 'Backslash' },
    ']': { keyCode: 221, code: 'BracketRight' },
    '}': { keyCode: 221, code: 'BracketRight' },
    "'": { keyCode: 222, code: 'Quote' },
    '"': { keyCode: 222, code: 'Quote' },
    AltGraph: { keyCode: 225, code: 'AltGraph' },
    Attn: { keyCode: 246, code: '' },
    CrSel: { keyCode: 247, code: 'Props' },
    ExSel: { keyCode: 248, code: '' },
    EraseEof: { keyCode: 249, code: '' },
    Play: { keyCode: 250, code: '' },
    ZoomOut: { keyCode: 251, code: '' },
    '0': { keyCode: 48, code: 'Digit0' },
    '1': { keyCode: 49, code: 'Digit1' },
    '2': { keyCode: 50, code: 'Digit2' },
    '3': { keyCode: 51, code: 'Digit3' },
    '4': { keyCode: 52, code: 'Digit4' },
    '5': { keyCode: 53, code: 'Digit5' },
    '6': { keyCode: 54, code: 'Digit6' },
    '7': { keyCode: 55, code: 'Digit7' },
    '8': { keyCode: 56, code: 'Digit8' },
    '9': { keyCode: 57, code: 'Digit9' },
    q: { keyCode: 81, code: 'KeyQ' },
    w: { keyCode: 87, code: 'KeyW' },
    e: { keyCode: 69, code: 'KeyE' },
    r: { keyCode: 82, code: 'KeyR' },
    t: { keyCode: 84, code: 'KeyT' },
    y: { keyCode: 89, code: 'KeyY' },
    u: { keyCode: 85, code: 'KeyU' },
    i: { keyCode: 73, code: 'KeyI' },
    o: { keyCode: 79, code: 'KeyO' },
    p: { keyCode: 80, code: 'KeyP' },
    a: { keyCode: 65, code: 'KeyA' },
    s: { keyCode: 83, code: 'KeyS' },
    d: { keyCode: 68, code: 'KeyD' },
    f: { keyCode: 70, code: 'KeyF' },
    g: { keyCode: 71, code: 'KeyG' },
    h: { keyCode: 72, code: 'KeyH' },
    j: { keyCode: 74, code: 'KeyJ' },
    k: { keyCode: 75, code: 'KeyK' },
    l: { keyCode: 76, code: 'KeyL' },
    z: { keyCode: 90, code: 'KeyZ' },
    x: { keyCode: 88, code: 'KeyX' },
    c: { keyCode: 67, code: 'KeyC' },
    v: { keyCode: 86, code: 'KeyV' },
    b: { keyCode: 66, code: 'KeyB' },
    n: { keyCode: 78, code: 'KeyN' },
    m: { keyCode: 77, code: 'KeyM' },
    Q: { keyCode: 81, code: 'KeyQ' },
    W: { keyCode: 87, code: 'KeyW' },
    E: { keyCode: 69, code: 'KeyE' },
    R: { keyCode: 82, code: 'KeyR' },
    T: { keyCode: 84, code: 'KeyT' },
    Y: { keyCode: 89, code: 'KeyY' },
    U: { keyCode: 85, code: 'KeyU' },
    I: { keyCode: 73, code: 'KeyI' },
    O: { keyCode: 79, code: 'KeyO' },
    P: { keyCode: 80, code: 'KeyP' },
    A: { keyCode: 65, code: 'KeyA' },
    S: { keyCode: 83, code: 'KeyS' },
    D: { keyCode: 68, code: 'KeyD' },
    F: { keyCode: 70, code: 'KeyF' },
    G: { keyCode: 71, code: 'KeyG' },
    H: { keyCode: 72, code: 'KeyH' },
    J: { keyCode: 74, code: 'KeyJ' },
    K: { keyCode: 75, code: 'KeyK' },
    L: { keyCode: 76, code: 'KeyL' },
    Z: { keyCode: 90, code: 'KeyZ' },
    X: { keyCode: 88, code: 'KeyX' },
    C: { keyCode: 67, code: 'KeyC' },
    V: { keyCode: 86, code: 'KeyV' },
    B: { keyCode: 66, code: 'KeyB' },
    N: { keyCode: 78, code: 'KeyN' },
    M: { keyCode: 77, code: 'KeyM' },
};
function keyCodeForKey(key) {
    if (keys[key])
        return keys[key].keyCode;
    if (key.length === 1)
        return key.toUpperCase().charCodeAt(0);
    return 0;
}
function codeForKey(key) {
    if (!keys[key])
        return '';
    return keys[key].code;
}
