import * as Protocol from '../types/tot';
import ExecutionContext from './ExecutionContext';
import ElementHandle from './ElementHandle';
import Session from './Session';
export default class JsHandle {
    protected client: Session;
    context: ExecutionContext;
    disposed: boolean;
    remoteObject: Protocol.Runtime.RemoteObject;
    constructor(context: ExecutionContext, client: Session, remoteObject: Protocol.Runtime.RemoteObject);
    /**
     * @return {!ExecutionContext}
     */
    executionContext(): ExecutionContext;
    getProperty(propertyName: string): Promise<JsHandle | undefined>;
    getProperties(): Promise<Map<string, JsHandle>>;
    /**
     * @return {!Promise<?Object>}
     */
    jsonValue(): Promise<any>;
    asElement(): ElementHandle | null;
    dispose(): Promise<void>;
    /**
     * @override
     * @return {string}
     */
    toString(): string;
}
