"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var releaseObject_1 = require("../utils/releaseObject");
var valueFromRemoteObject_1 = require("../utils/valueFromRemoteObject");
// TODO: context, remoteObject & disposed should be private.
var JsHandle = /** @class */ (function () {
    function JsHandle(context, client, remoteObject) {
        this.disposed = false;
        this.context = context;
        this.client = client;
        this.remoteObject = remoteObject;
    }
    /**
     * @return {!ExecutionContext}
     */
    JsHandle.prototype.executionContext = function () {
        return this.context;
    };
    JsHandle.prototype.getProperty = function (propertyName) {
        return __awaiter(this, void 0, void 0, function () {
            var objectHandle, properties, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.context.evaluateHandle(function (object, propertyName) {
                            var result = { __proto__: null };
                            result[propertyName] = object[propertyName];
                            return result;
                        }, this, propertyName)];
                    case 1:
                        objectHandle = _a.sent();
                        if (!objectHandle) return [3 /*break*/, 4];
                        return [4 /*yield*/, objectHandle.getProperties()];
                    case 2:
                        properties = _a.sent();
                        result = properties.get(propertyName);
                        return [4 /*yield*/, objectHandle.dispose()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, result];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    JsHandle.prototype.getProperties = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, result, _i, _a, property;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.client.send('Runtime.getProperties', {
                            objectId: this.remoteObject.objectId,
                            ownProperties: true,
                        })];
                    case 1:
                        response = _b.sent();
                        result = new Map();
                        for (_i = 0, _a = response.result; _i < _a.length; _i++) {
                            property = _a[_i];
                            if (!property.enumerable)
                                continue;
                            if (property.value) {
                                result.set(property.name, this.context.objectHandleFactory(property.value));
                            }
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * @return {!Promise<?Object>}
     */
    JsHandle.prototype.jsonValue = function () {
        return __awaiter(this, void 0, void 0, function () {
            var jsonString;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.remoteObject.objectId) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.context.evaluate(function (object) { return JSON.stringify(object); }, this)];
                    case 1:
                        jsonString = _a.sent();
                        return [2 /*return*/, JSON.parse(jsonString)];
                    case 2: return [2 /*return*/, valueFromRemoteObject_1.default(this.remoteObject)];
                }
            });
        });
    };
    JsHandle.prototype.asElement = function () {
        return null;
    };
    JsHandle.prototype.dispose = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.disposed)
                            return [2 /*return*/];
                        this.disposed = true;
                        return [4 /*yield*/, releaseObject_1.default(this.client, this.remoteObject)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @override
     * @return {string}
     */
    JsHandle.prototype.toString = function () {
        if (this.remoteObject.objectId) {
            var type = this.remoteObject.subtype || this.remoteObject.type;
            return 'JsHandle@' + type;
        }
        return 'JsHandle:' + valueFromRemoteObject_1.default(this.remoteObject);
    };
    return JsHandle;
}());
exports.default = JsHandle;
