import { Connection } from './Connection';
export declare const CHROME_PROFILE_PATH: string;
export interface LauncherParams {
    appMode?: boolean;
    args?: string[];
    devtools?: boolean;
    dumpio?: boolean;
    env?: {
        [key: string]: string | undefined;
    };
    executablePath: string;
    handleSIGINT?: boolean;
    handleSIGTERM?: boolean;
    handleSIGHUP?: boolean;
    headless?: boolean;
    ignoreHTTPSErrors?: boolean;
    proxy?: string;
    slowMo?: number;
    timeout?: number;
    userDataDir?: string;
}
export declare class Launcher {
    static launch(options: LauncherParams): Promise<{
        connection: Connection;
        closeCallback: () => Promise<{}>;
        userDataDir: string;
    }>;
}
