"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Code.
var Multimap = /** @class */ (function () {
    function Multimap() {
        this.map = new Map();
    }
    Multimap.prototype.set = function (key, value) {
        var set = this.map.get(key);
        if (!set) {
            set = new Set();
            this.map.set(key, set);
        }
        set.add(value);
    };
    Multimap.prototype.get = function (key) {
        var result = this.map.get(key);
        if (!result)
            result = new Set();
        return result;
    };
    Multimap.prototype.has = function (key) {
        return this.map.has(key);
    };
    Multimap.prototype.hasValue = function (key, value) {
        var set = this.map.get(key);
        if (!set)
            return false;
        return set.has(value);
    };
    Object.defineProperty(Multimap.prototype, "size", {
        get: function () {
            return this.map.size;
        },
        enumerable: true,
        configurable: true
    });
    Multimap.prototype.delete = function (key, value) {
        var values = this.get(key);
        var result = values.delete(value);
        if (!values.size)
            this.map.delete(key);
        return result;
    };
    Multimap.prototype.deleteAll = function (key) {
        this.map.delete(key);
    };
    Multimap.prototype.firstValue = function (key) {
        var set = this.map.get(key);
        if (!set)
            return null;
        return set.values().next().value;
    };
    Multimap.prototype.firstKey = function () {
        return this.map.keys().next().value;
    };
    Multimap.prototype.valuesArray = function () {
        var _this = this;
        var result = [];
        this.map.forEach(function (key) {
            result.push.apply(result, Array.from(_this.map.get(key).values()));
        });
        return result;
    };
    Multimap.prototype.keysArray = function () {
        return Array.from(this.map.keys());
    };
    Multimap.prototype.clear = function () {
        this.map.clear();
    };
    return Multimap;
}());
exports.default = Multimap;
