import FrameManager from './FrameManager';
import Frame from './Frame';
export interface INavigatorWatcherOptions {
    idleInflight?: number;
    idleTime?: number;
    timeout?: number;
    waitUntil: ENavigatorWatcher | ENavigatorWatcher[];
}
export declare enum ENavigatorWatcher {
    DOMContentLoaded = "domcontentloaded",
    Load = "load",
    NetworkIdle = "networkidle0",
    NetworkAlmostIdle = "networkidle2",
}
export default class NavigatorWatcher {
    private client;
    private eventListeners;
    private frameId;
    private idleTimer;
    private maximumTimer;
    private pendingEvents;
    private pendingEventsCallback;
    private timeout;
    private frameManager;
    private frame;
    private expectedLifecycle;
    private initialLoaderId;
    private lifecycleCompleteCallback;
    private _navigationPromise;
    constructor(frameManager: FrameManager, frame: Frame | undefined, options?: INavigatorWatcherOptions);
    navigationPromise(): Promise<any>;
    checkLifecycleComplete(): void;
    private createTimeoutPromise();
    private cleanup();
    private onLifecycleEvent(event);
    waitForNavigation(): Promise<Error | null>;
    cancel(): void;
}
