"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Native.
var events_1 = require("events");
// Package.
var debug = require("debug");
var Multimap_1 = require("./Multimap");
var Request_1 = require("./Request");
var Response_1 = require("./Response");
// Code.
var debugErrorNetworkManager = debug('di:error:networkManager');
var NetworkManager = /** @class */ (function (_super) {
    __extends(NetworkManager, _super);
    function NetworkManager(client) {
        var _this = _super.call(this) || this;
        _this.attemptedAuthentications = new Set();
        _this.interceptionIdToRequest = new Map();
        // private offline = false;
        _this.protocolRequestInterceptionEnabled = false;
        _this.requestHashToRequestIds = new Multimap_1.default();
        _this.requestHashToInterceptionIds = new Multimap_1.default();
        _this.requestIdToRequest = new Map();
        _this.userRequestInterceptionEnabled = false;
        _this.extraHTTPHeaders = {};
        _this.client = client;
        _this.client.on('Network.requestWillBeSent', _this.onRequestWillBeSent.bind(_this));
        _this.client.on('Network.requestIntercepted', _this.onRequestIntercepted.bind(_this));
        _this.client.on('Network.responseReceived', _this.onResponseReceived.bind(_this));
        _this.client.on('Network.loadingFinished', _this.onLoadingFinished.bind(_this));
        _this.client.on('Network.loadingFailed', _this.onLoadingFailed.bind(_this));
        return _this;
    }
    Object.defineProperty(NetworkManager, "Events", {
        get: function () {
            return {
                Request: 'request',
                Response: 'response',
                RequestFailed: 'requestfailed',
                RequestFinished: 'requestfinished',
            };
        },
        enumerable: true,
        configurable: true
    });
    NetworkManager.prototype.handleRequestRedirect = function (request, redirectStatus, redirectHeaders) {
        var response = new Response_1.default(this.client, request, redirectStatus, redirectHeaders);
        request.response = response;
        if (request.requestId) {
            this.requestIdToRequest.delete(request.requestId);
        }
        if (request.interceptionId) {
            this.interceptionIdToRequest.delete(request.interceptionId);
            this.attemptedAuthentications.delete(request.interceptionId);
        }
        this.emit(NetworkManager.Events.Response, response);
        this.emit(NetworkManager.Events.RequestFinished, request);
    };
    NetworkManager.prototype.handleRequestStart = function (requestId, interceptionId, url, resourceType, requestPayload) {
        var request = new Request_1.default(this.client, requestId, interceptionId, this.userRequestInterceptionEnabled, url, resourceType, requestPayload);
        if (requestId) {
            this.requestIdToRequest.set(requestId, request);
        }
        if (interceptionId) {
            this.interceptionIdToRequest.set(interceptionId, request);
        }
        this.emit(NetworkManager.Events.Request, request);
    };
    NetworkManager.prototype.onLoadingFailed = function (event) {
        var request = this.requestIdToRequest.get(event.requestId);
        // For certain requestIds we never receive requestWillBeSent event.
        // @see https://crbug.com/750469
        if (!request)
            return;
        request.completePromiseFulfill.call(null);
        if (request.requestId) {
            this.requestIdToRequest.delete(request.requestId);
        }
        if (request.interceptionId) {
            this.interceptionIdToRequest.delete(request.interceptionId);
            this.attemptedAuthentications.delete(request.interceptionId);
        }
        this.emit(NetworkManager.Events.RequestFailed, request);
    };
    NetworkManager.prototype.onLoadingFinished = function (event) {
        var request = this.requestIdToRequest.get(event.requestId);
        // For certain requestIds we never receive requestWillBeSent event.
        // @see https://crbug.com/750469
        if (!request)
            return;
        request.completePromiseFulfill.call(null);
        if (request.requestId) {
            this.requestIdToRequest.delete(request.requestId);
        }
        if (request.interceptionId) {
            this.interceptionIdToRequest.delete(request.interceptionId);
            this.attemptedAuthentications.delete(request.interceptionId);
        }
        this.emit(NetworkManager.Events.RequestFinished, request);
    };
    NetworkManager.prototype.onRequestIntercepted = function (event) {
        if (event.authChallenge) {
            var response = 'Default';
            if (this.attemptedAuthentications.has(event.interceptionId)) {
                response = 'CancelAuth';
            }
            else if (this.credentials) {
                response = 'ProvideCredentials';
                this.attemptedAuthentications.add(event.interceptionId);
            }
            var _a = this.credentials || {
                username: undefined,
                password: undefined,
            }, username = _a.username, password = _a.password;
            var params = {
                interceptionId: event.interceptionId,
                authChallengeResponse: { response: response, username: username, password: password },
            };
            this.client
                .send('Network.continueInterceptedRequest', params)
                .catch(debugErrorNetworkManager);
            return;
        }
        if (!this.userRequestInterceptionEnabled &&
            this.protocolRequestInterceptionEnabled) {
            var params = {
                interceptionId: event.interceptionId,
            };
            this.client
                .send('Network.continueInterceptedRequest', params)
                .catch(debugErrorNetworkManager);
        }
        var requestHash = generateRequestHash(event.request);
        var requestId = this.requestHashToRequestIds.firstValue(requestHash);
        if (requestId) {
            this.requestHashToRequestIds.delete(requestHash, requestId);
            this.handleRequestStart(requestId, event.interceptionId, event.request.url, event.resourceType, event.request);
        }
        else {
            this.requestHashToInterceptionIds.set(requestHash, event.interceptionId);
            this.handleRequestStart(null, event.interceptionId, event.request.url, event.resourceType, event.request);
        }
    };
    NetworkManager.prototype.onResponseReceived = function (event) {
        var request = this.requestIdToRequest.get(event.requestId);
        // FileUpload sends a response without a matching request.
        if (!request)
            return;
        var response = new Response_1.default(this.client, request, event.response.status, event.response.headers);
        request.response = response;
        this.emit(NetworkManager.Events.Response, response);
    };
    NetworkManager.prototype.onRequestWillBeSent = function (event) {
        if (this.protocolRequestInterceptionEnabled) {
            // All redirects are handled in requestIntercepted.
            if (event.redirectResponse) {
                return;
            }
            var requestHash = generateRequestHash(event.request);
            var interceptionId = this.requestHashToInterceptionIds.firstValue(requestHash);
            var request = interceptionId
                ? this.interceptionIdToRequest.get(interceptionId)
                : null;
            if (request) {
                request.requestId = event.requestId;
                this.requestIdToRequest.set(event.requestId, request);
                this.requestHashToInterceptionIds.delete(requestHash, interceptionId);
            }
            else {
                this.requestHashToRequestIds.set(requestHash, event.requestId);
            }
            return;
        }
        if (event.redirectResponse) {
            var request = this.requestIdToRequest.get(event.requestId);
            if (request) {
                this.handleRequestRedirect(request, event.redirectResponse.status, event.redirectResponse.headers);
            }
        }
        this.handleRequestStart(event.requestId, null, event.request.url, "" + event.type, event.request);
    };
    NetworkManager.prototype.setUserAgent = function (userAgent) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.send('Network.setUserAgentOverride', { userAgent: userAgent })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    NetworkManager.prototype.authenticate = function (credentials) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.credentials = credentials;
                        return [4 /*yield*/, this.updateProtocolRequestInterception()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    NetworkManager.prototype.updateProtocolRequestInterception = function () {
        return __awaiter(this, void 0, void 0, function () {
            var enabled, patterns;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        enabled = this.userRequestInterceptionEnabled || !!this.credentials;
                        if (enabled === this.protocolRequestInterceptionEnabled)
                            return [2 /*return*/];
                        this.protocolRequestInterceptionEnabled = enabled;
                        patterns = enabled ? [{ urlPattern: '*' }] : [];
                        return [4 /*yield*/, Promise.all([
                                this.client.send('Network.setCacheDisabled', { cacheDisabled: enabled }),
                                this.client.send('Network.setRequestInterception', { patterns: patterns }),
                            ])];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return NetworkManager;
}(events_1.EventEmitter));
exports.default = NetworkManager;
function generateRequestHash(request) {
    var normalizedURL = request.url;
    try {
        // Decoding is necessary to normalize URLs. @see crbug.com/759388
        // The method will throw if the URL is malformed. In this case,
        // consider URL to be normalized as-is.
        normalizedURL = decodeURI(request.url);
    }
    catch (e) { }
    var hash = {
        headers: {},
        url: normalizedURL,
        method: request.method,
        postData: request.postData,
    };
    if (!normalizedURL.startsWith('data:')) {
        var headers = Object.keys(request.headers);
        headers.sort();
        for (var _i = 0, headers_1 = headers; _i < headers_1.length; _i++) {
            var header = headers_1[_i];
            if (header === 'Accept' ||
                header === 'Referer' ||
                header === 'X-DevTools-Emulate-Network-Conditions-Client-Id')
                continue;
            hash.headers[header] = request.headers[header];
        }
    }
    return JSON.stringify(hash);
}
