/// <reference types="node" />
import { EventEmitter } from 'events';
export interface Message {
    method: MessageMethod;
    params: MessageParams;
}
export declare type MessageMethod = string;
export declare type MessageParams = {
    [key: string]: number | boolean | string;
};
export default class NetworkRecorder extends EventEmitter {
    private networkManager;
    private records;
    private startedRequestCount;
    private finishedRequestCount;
    constructor();
    private readonly EventTypes;
    private activeRequestCount();
    private onRequestStarted(request);
    private onRequestFinished(request);
    private onRequestWillBeSent(params);
    private onRequestServedFromCache(params);
    private onResponseReceived(params);
    private onDataReceived(params);
    private onLoadingFinished(params);
    private onLoadingFailed(params);
    private onResourceChangedPriority(params);
    isIdle(): boolean;
    isBusy(): boolean;
    is2Idle(): boolean;
    is2Buzy(): boolean;
    getRecords(): any[];
    dispatch(method: MessageMethod, params: MessageParams): void;
}
