import * as Protocol from '../types/tot';
import Target from './Target';
import { TargetHistory } from './Browser';
import { RunnerAudits } from './Runner';
export interface OutputReport {
    id: string;
    targetId: string;
    version: string;
    generated: string;
    audits: RunnerAudits;
}
export interface OutputResult {
    id: string;
    generated: string;
    targets: Protocol.Target.TargetInfo[];
    targetsHistory: TargetHistory[];
    reports: OutputReport[];
}
export default class Output {
    static generateReport(targetId: string, audits: RunnerAudits): Promise<OutputReport>;
    static generateResult(targets: Target[], targetsHistory: TargetHistory[], reports: OutputReport[]): Promise<OutputResult>;
}
