"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Native.
var events_1 = require("events");
// Package.
var _ = require("lodash");
var debug = require("debug");
var FrameManager_1 = require("./FrameManager");
var Helper_1 = require("./Helper");
var Element_1 = require("./Element");
var EmulationManager_1 = require("./EmulationManager");
var NavigatorWatcher_1 = require("./NavigatorWatcher");
var NetworkManager_1 = require("./NetworkManager");
var Input_1 = require("./Input");
var Tracer_1 = require("./Tracer");
var deviceDescriptors_1 = require("../config/deviceDescriptors");
// Code.
var debugVerbose = debug('di:verbose:page');
var debugWarn = debug('di:warn:page');
var Page = /** @class */ (function (_super) {
    __extends(Page, _super);
    function Page(client, frameTree, userDataDir) {
        var _this = _super.call(this) || this;
        _this.client = client;
        _this.initialFrameTree = frameTree;
        _this.keyboard = new Input_1.Keyboard(_this.client);
        _this.mouse = new Input_1.Mouse(_this.client, _this.keyboard);
        _this.touchscreen = new Input_1.Touchscreen(_this.client, _this.keyboard);
        _this.frameManager = new FrameManager_1.default(_this.client, frameTree, _this);
        _this.networkManager = new NetworkManager_1.default(client);
        _this.emulationManager = new EmulationManager_1.default();
        _this.userDataDir = userDataDir;
        client.on('Security.certificateError', function (event) {
            return _this.onCertificateError(event);
        });
        return _this;
    }
    Object.defineProperty(Page, "Events", {
        get: function () {
            return {
                Console: 'console',
                Dialog: 'dialog',
                Error: 'error',
                FrameAttached: 'frameattached',
                FrameDetached: 'framedetached',
                FrameNavigated: 'framenavigated',
                Load: 'load',
                Metrics: 'metrics',
                PageError: 'pageerror',
                Request: 'request',
                RequestFailed: 'requestfailed',
                RequestFinished: 'requestfinished',
                Response: 'response',
            };
        },
        enumerable: true,
        configurable: true
    });
    Page.create = function (client, userDataDir) {
        return __awaiter(this, void 0, void 0, function () {
            var resourceTreeResult, frameTree, page, setLifecycleEventsEnabledParams, setOverrideCertificateErrorsParameters;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.send('Page.enable')];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, client.send('Page.getResourceTree')];
                    case 2:
                        resourceTreeResult = _a.sent();
                        frameTree = resourceTreeResult.frameTree;
                        page = new Page(client, frameTree, userDataDir);
                        page.setMaxListeners(20);
                        return [4 /*yield*/, Promise.all([
                                client.send('Network.enable'),
                                client.send('Runtime.enable'),
                                client.send('Security.enable'),
                                client.send('Performance.enable'),
                                client.send('Console.enable'),
                            ])];
                    case 3:
                        _a.sent();
                        setLifecycleEventsEnabledParams = {
                            enabled: true,
                        };
                        return [4 /*yield*/, client.send('Page.setLifecycleEventsEnabled', setLifecycleEventsEnabledParams)];
                    case 4:
                        _a.sent();
                        setOverrideCertificateErrorsParameters = {
                            override: true,
                        };
                        return [4 /*yield*/, client.send('Security.setOverrideCertificateErrors', setOverrideCertificateErrorsParameters)];
                    case 5:
                        _a.sent();
                        // /!\ TODO: Before deploying it, check is real impact.
                        // It might be
                        // const setAdBlockingEnabled: Protocol.Page.SetAdBlockingEnabledParameters = {
                        //   enabled: true,
                        // }
                        // await client.send(
                        //   'Page.setAdBlockingEnabled',
                        //   setAdBlockingEnabled
                        // );
                        // TODO: handle it in a way that allow the user to not automatically
                        // close the browser.
                        // client.send('Page.bringToFront')
                        return [2 /*return*/, page];
                }
            });
        });
    };
    Page.prototype.onCertificateError = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            var handleCertificateErrorParams, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        handleCertificateErrorParams = {
                            eventId: event.eventId,
                            action: 'continue',
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.client.send('Security.handleCertificateError', handleCertificateErrorParams)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        debugWarn("Can not send Security.handleCertificateError");
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.authenticate = function (credentials) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.networkManager.authenticate(credentials)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.mainFrame = function () {
        return this.frameManager.mainFrame;
    };
    Page.prototype.mainFrameId = function () {
        var mainFrame = this.frameManager.mainFrame;
        if (mainFrame) {
            return mainFrame.id;
        }
        else {
            return this.client.targetId;
        }
    };
    Page.prototype.startRecordDevtoolLogs = function () {
        this.client.devtoolLogManager.reset();
        this.client.devtoolLogManager.beginRecording();
    };
    Page.prototype.endRecordDevtoolLogs = function () {
        this.client.devtoolLogManager.endRecording();
        return this.client.devtoolLogManager.getRecords();
    };
    Page.prototype.getMeta = function () {
        return {
            frameId: this.mainFrameId(),
            targetId: this.client.targetId,
            targetVersion: this.client.targetVersion,
        };
    };
    Page.prototype.getNetworkRecords = function () {
        return this.client.getNetworkRecords();
    };
    Page.prototype.beginNetworkStatusMonitoring = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.beginNetworkStatusMonitoring(url)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.endNetworkStatusMonitoring = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.endNetworkStatusMonitoring()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.navigate = function (url, options) {
        return __awaiter(this, void 0, void 0, function () {
            function _navigate(client, url, referrer) {
                return __awaiter(this, void 0, void 0, function () {
                    var error_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                return [4 /*yield*/, client.send('Page.navigate', { url: url, referrer: referrer })];
                            case 1:
                                _a.sent();
                                return [3 /*break*/, 3];
                            case 2:
                                error_1 = _a.sent();
                                return [2 /*return*/, error_1];
                            case 3: return [2 /*return*/];
                        }
                    });
                });
            }
            var referrer, requests, eventListeners, watcher, navigationPromise, error, request, mainFrame;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debugVerbose("Navigate to " + url);
                        return [4 /*yield*/, this.beginNetworkStatusMonitoring(url)];
                    case 1:
                        _a.sent();
                        referrer = this.networkManager.extraHTTPHeaders['referer'];
                        requests = new Map();
                        eventListeners = [
                            Helper_1.default.addEventListener(this.networkManager, NetworkManager_1.default.Events.Request, function (request) { return requests.set(request.url, request); }),
                        ];
                        watcher = new NavigatorWatcher_1.default(this.frameManager, this.frameManager.mainFrame, options);
                        navigationPromise = watcher.navigationPromise();
                        return [4 /*yield*/, Promise.race([
                                _navigate(this.client, url, referrer),
                                navigationPromise,
                            ])];
                    case 2:
                        error = _a.sent();
                        if (!!error) return [3 /*break*/, 4];
                        return [4 /*yield*/, navigationPromise];
                    case 3:
                        error = _a.sent();
                        _a.label = 4;
                    case 4:
                        watcher.cancel();
                        Helper_1.default.removeEventListeners(eventListeners);
                        if (error)
                            throw error;
                        return [4 /*yield*/, this.endNetworkStatusMonitoring()];
                    case 5:
                        _a.sent();
                        mainFrame = this.mainFrame();
                        if (mainFrame) {
                            request = requests.get(mainFrame.url);
                        }
                        return [2 /*return*/, request ? request.response : null];
                }
            });
        });
    };
    Page.prototype.getTargetId = function () {
        return this.client.targetId;
    };
    Page.prototype.emit = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        debugVerbose("emit event => " + event);
        if (event === Tracer_1.ETracer.Span) {
            var message = _.first(args);
            this.client.setEvent(message);
        }
        return (_a = this.client).emit.apply(_a, [event].concat(args));
        var _a;
    };
    Page.prototype.on = function (event, listener) {
        debugVerbose("listen on event => " + event);
        this.client.on(event, listener);
        return this;
    };
    Page.prototype.once = function (event, listener) {
        debugVerbose("listen once event => " + event);
        this.client.once(event, listener);
        return this;
    };
    Page.prototype.off = function (event, listener) {
        debugVerbose("unlisten event => " + event);
        this.client.removeListener(event, listener);
        return this;
    };
    // TODO: Handle both `A` and `B` types at `client.send` level.
    Page.prototype.send = function (method, params) {
        return this.client.send(method, params);
    };
    // TODO: Following method should to be updated in order to
    // works in multiple frames context.
    Page.prototype.querySelectorAll = function (selector) {
        var _this = this;
        return this.send('DOM.getDocument')
            .then(function (result) {
            var nodeId = result.root.nodeId;
            return _this.send('DOM.querySelectorAll', {
                nodeId: nodeId,
                selector: selector,
            });
        })
            .then(function (nodeList) {
            var elementList = [];
            if (nodeList && nodeList.nodeIds) {
                nodeList.nodeIds.forEach(function (nodeId) {
                    if (nodeId !== 0) {
                        elementList.push(new Element_1.default({ nodeId: nodeId }, _this));
                    }
                });
            }
            return elementList;
        });
    };
    // TODO: Following method should to be updated in order to
    // works in multiple frames context.
    Page.prototype.getObjectProperty = function (objectId, propName) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.send('Runtime.getProperties', {
                objectId: objectId,
                accessorPropertiesOnly: true,
                generatePreview: false,
                ownProperties: false,
            })
                .then(function (properties) {
                var propertyForName = properties.result.find(function (property) { return property.name === propName; });
                if (propertyForName && propertyForName.value) {
                    resolve(propertyForName.value.value);
                }
                else {
                    resolve(null);
                }
            })
                .catch(reject);
        });
    };
    Page.prototype.content = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.frameManager.mainFrame) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.frameManager.mainFrame.content()];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [2 /*return*/, null];
                }
            });
        });
    };
    Page.prototype.setContent = function (html) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.frameManager.mainFrame) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.frameManager.mainFrame.setContent(html)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.text = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.frameManager.mainFrame) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.frameManager.mainFrame.text()];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [2 /*return*/, null];
                }
            });
        });
    };
    Page.prototype.emulate = function (deviceName) {
        return __awaiter(this, void 0, void 0, function () {
            var device;
            return __generator(this, function (_a) {
                device = deviceDescriptors_1.default[deviceName];
                if (!device) {
                    device = deviceDescriptors_1.default['Nexus 6'];
                    debugWarn("Device " + deviceName + " not found");
                }
                return [2 /*return*/, Promise.all([
                        this.setViewport(device.viewport),
                        this.setUserAgent(device.userAgent),
                    ])];
            });
        });
    };
    Page.prototype.screenshot = function (params) {
        if (params === void 0) { params = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var screenshotType, targetId, metrics, width, height, clip, mobile, deviceScaleFactor, landscape, screenOrientation, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        screenshotType = 'jpeg';
                        targetId = this.client.targetId;
                        return [4 /*yield*/, this.send('Target.activateTarget', { targetId: targetId })];
                    case 1:
                        _a.sent();
                        debugVerbose("Target " + targetId + " activated");
                        return [4 /*yield*/, this.send('Page.getLayoutMetrics')];
                    case 2:
                        metrics = _a.sent();
                        debugVerbose("Page layout metrics: %j", metrics);
                        width = Math.ceil(metrics.contentSize.width);
                        height = Math.ceil(metrics.contentSize.height);
                        clip = { x: 0, y: 0, width: width, height: height, scale: 1 };
                        mobile = this.viewport.isMobile || false;
                        deviceScaleFactor = this.viewport.deviceScaleFactor || 1;
                        landscape = this.viewport.isLandscape || false;
                        screenOrientation = landscape
                            ? { angle: 90, type: 'landscapePrimary' }
                            : { angle: 0, type: 'portraitPrimary' };
                        return [4 /*yield*/, this.send('Emulation.setDeviceMetricsOverride', {
                                mobile: mobile,
                                width: width,
                                height: height,
                                deviceScaleFactor: deviceScaleFactor,
                                screenOrientation: screenOrientation,
                            })];
                    case 3:
                        _a.sent();
                        debugVerbose("Emulation override done");
                        return [4 /*yield*/, this.send('Page.captureScreenshot', {
                                format: screenshotType,
                                quality: params.quality || 100,
                                clip: clip,
                            })];
                    case 4:
                        result = _a.sent();
                        debugVerbose("Page.captureScreenshot done");
                        // Set back the view port to his previous settings.
                        // await this.setViewport(this.viewport);
                        // Returns the screenshot as base64.
                        return [2 /*return*/, result.data];
                }
            });
        });
    };
    Page.prototype.setViewport = function (viewport) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.viewport = viewport;
                        return [4 /*yield*/, this.emulationManager.emulateViewport(this.client, viewport)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.setUserAgent = function (userAgent) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.networkManager.setUserAgent(userAgent)];
            });
        });
    };
    return Page;
}(events_1.EventEmitter));
exports.default = Page;
