import * as Protocol from '../types/protocol';
export default class ProtocolCodeGenerator {
    private code;
    private indent;
    private indentStack;
    private refs;
    readonly currentIndent: string;
    generate(protocol: Protocol.IProtocol): string;
    private generatorMissingRefs(domainName, refs);
    private getRefs(domainName);
    private gatherRefs(domain);
    private gatherRefsFromDescs(descs, refs);
    private gatherRefsFromDesc(desc, refs);
    private appendProtocolVersionComment(version?);
    private generateDomainTypeNamespace(domainName, cb);
    private appendType(type);
    private appendEventParametersType(event);
    private block(cb);
    private append(line);
    private generateProperty(desc);
    private appendComment(obj);
    private appendCommandTypes(command);
    private returnTypeName(name, domainName?);
    private parametersTypeName(name, domainName?);
    private generateObjectTypeAlias(name, props);
    private namedTypeString(desc);
    private typeString(desc, isArray?);
}
