/// <reference types="node" />
import * as Protocol from '../types/tot';
import Response from './Response';
import Session from './Session';
export default class Request {
    private allowInterception;
    private client;
    private headers;
    private interceptionHandled;
    private method;
    private postData;
    private resourceType;
    completePromise: any;
    completePromiseFulfill: any;
    interceptionId: string | null;
    requestId: string | null;
    response: Response | null;
    url: string | undefined;
    constructor(client: Session, requestId: string | null, interceptionId: string | null, allowInterception: boolean, url: string | undefined, resourceType: string, payload: Protocol.Network.Request);
    abort(): Promise<void>;
    continue(overrides?: any): Promise<void>;
    respond(response: {
        status: number;
        headers: {
            [key: string]: string;
        };
        contentType: string;
        body: string | Buffer;
    }): Promise<void>;
}
