import { AuditResult } from './Audit';
import { GathererResult } from './Gatherer';
import Page from './Page';
import { OutputReport } from './Output';
import { DevtoolLogRecord } from './DevtoolLogManager';
import * as Protocol from '../types/tot';
export declare type RunnerArtifacts = Map<string, GathererResult<any> | DevtoolLogRecord[]>;
export declare type RunnerAudits = Map<string, AuditResult<any, any>>;
export interface IRunnerConfig {
    headers?: string;
    emulate?: string;
    audits: ModuleConfig[];
    gatherers: ModuleConfig[];
    initialScript?: string;
    auth?: {
        username: string;
        password: string;
    };
}
export interface ModuleConfig {
    depth: number;
    path: string;
}
export default class Runner {
    private config;
    private page;
    private targetId;
    private url?;
    private artifacts;
    private audits;
    private callback;
    private tracer;
    private depth;
    private updateTargetsHistory;
    constructor(targetId: string, updateTargetsHistory: (targetInfo: Protocol.Target.TargetInfo, reason: string) => void, page: Page, config: IRunnerConfig, callback: (report: OutputReport) => void, depth: number, url?: string);
    private loadModules<T>(modules, ...args);
    private prepare();
    private dispose();
    private runGatherers<A>();
    private runAudits<A, B>();
    run(): Promise<void>;
}
