"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Package.
var _ = require("lodash");
var debug = require("debug");
// Internal.
var error = require("../utils/error");
var delay_1 = require("../utils/delay");
var Output_1 = require("./Output");
var Tracer_1 = require("./Tracer");
// Code.
var debugVerbose = debug('di:verbose:runner');
var Runner = /** @class */ (function () {
    function Runner(targetId, updateTargetsHistory, page, config, callback, depth, url) {
        this.artifacts = new Map();
        this.audits = new Map();
        this.depth = 0;
        this.targetId = targetId;
        this.page = page;
        this.config = config;
        this.url = url;
        this.callback = callback;
        this.tracer = new Tracer_1.default(page);
        this.depth = depth;
        this.updateTargetsHistory = updateTargetsHistory;
    }
    Runner.prototype.loadModules = function (modules) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _.compact(modules.map(function (m) {
                            if (m.depth < _this.depth) {
                                return;
                            }
                            try {
                                var ModuleClass = require(m.path);
                                if (ModuleClass.default) {
                                    ModuleClass = ModuleClass.default;
                                }
                                else {
                                    // TODO: Find a way to handle modules without default export.
                                    throw new Error("Only default export are allowed for module, check " + m.path);
                                }
                                return new (ModuleClass.bind.apply(ModuleClass, [void 0].concat(args)))();
                            }
                            catch (err) {
                                if (err.code === 'MODULE_NOT_FOUND') {
                                    throw new error.ModuleError("Can not load module '" + m.path + "'");
                                }
                                throw err;
                            }
                        }))];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Runner.prototype.prepare = function () {
        return __awaiter(this, void 0, void 0, function () {
            var headers, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.tracer.prepare()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.page.startRecordDevtoolLogs()];
                    case 2:
                        _a.sent();
                        if (!this.config.auth) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.page.authenticate(this.config.auth)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (!this.config.headers) return [3 /*break*/, 8];
                        _a.label = 5;
                    case 5:
                        _a.trys.push([5, 7, , 8]);
                        headers = JSON.parse(this.config.headers);
                        return [4 /*yield*/, this.page.send('Network.setExtraHTTPHeaders', { headers: headers })];
                    case 6:
                        _a.sent();
                        return [3 /*break*/, 8];
                    case 7:
                        err_1 = _a.sent();
                        throw new Error("Failed to parse headers: " + this.config.headers);
                    case 8:
                        if (!this.config.initialScript) return [3 /*break*/, 10];
                        return [4 /*yield*/, this.page.send('Page.addScriptToEvaluateOnNewDocument', {
                                source: this.config.initialScript,
                            })];
                    case 9:
                        _a.sent();
                        _a.label = 10;
                    case 10: return [4 /*yield*/, this.page.emulate(this.config.emulate || 'iPhone 6')];
                    case 11:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Runner.prototype.dispose = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.tracer.dispose()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.artifacts.set('devtool-logs', this.page.endRecordDevtoolLogs())];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.artifacts.set('network-records', this.page.getNetworkRecords())];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Runner.prototype.runGatherers = function () {
        return __awaiter(this, void 0, void 0, function () {
            var gatherers, mainFrame, mainFrameUrl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loadModules(this.config.gatherers, this.page)];
                    case 1:
                        gatherers = _a.sent();
                        return [4 /*yield*/, Promise.all(gatherers.map(function (gatherer) { return gatherer.prepare(); }))];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.tracer.beforeLoad()];
                    case 3:
                        _a.sent();
                        if (!this.url) return [3 /*break*/, 5];
                        this.updateTargetsHistory({
                            targetId: this.targetId,
                            type: 'page',
                            title: this.url,
                            url: this.url,
                            attached: true,
                        }, 'navigated');
                        return [4 /*yield*/, this.page.navigate(this.url)];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 5:
                        mainFrame = this.page.mainFrame();
                        if (!mainFrame) return [3 /*break*/, 7];
                        mainFrameUrl = mainFrame.url;
                        debugVerbose("No URL provided, switch to mainFrameUrl: " + mainFrameUrl);
                        this.updateTargetsHistory({
                            targetId: this.targetId,
                            type: 'page',
                            title: mainFrameUrl,
                            url: mainFrameUrl,
                            attached: true,
                        }, 'navigated');
                        return [4 /*yield*/, this.page.beginNetworkStatusMonitoring(mainFrameUrl)];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7: 
                    // TODO: we should warn here no ?
                    // TODO: Better to use the navigator watcher here...
                    return [4 /*yield*/, delay_1.default(5000)];
                    case 8:
                        // TODO: we should warn here no ?
                        // TODO: Better to use the navigator watcher here...
                        _a.sent();
                        return [4 /*yield*/, this.page.endNetworkStatusMonitoring()];
                    case 9:
                        _a.sent();
                        _a.label = 10;
                    case 10: return [4 /*yield*/, this.tracer.afterLoad()];
                    case 11:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(gatherers.map(function (gatherer) { return gatherer.run(); }))];
                    case 12:
                        _a.sent();
                        return [4 /*yield*/, delay_1.default(10000)];
                    case 13:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(gatherers.map(function (gatherer) { return gatherer.dispose(); }))];
                    case 14:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(gatherers.map(function (gatherer) { return gatherer.collect(); }))];
                    case 15: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Runner.prototype.runAudits = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var audits;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loadModules(this.config.audits, this.artifacts)];
                    case 1:
                        audits = _a.sent();
                        return [4 /*yield*/, Promise.all(audits.map(function (audit) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/, audit.run()];
                            }); }); }))];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(audits.map(function (audit) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/, audit.collect()];
                            }); }); }))];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Runner.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var gathererResults, auditResults, report;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debugVerbose("start");
                        return [4 /*yield*/, this.prepare()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.runGatherers()];
                    case 2:
                        gathererResults = _a.sent();
                        gathererResults.forEach(function (result) {
                            _this.artifacts.set(result.name, result);
                        });
                        // TODO: only use for dev purpose so far, used
                        // to allow a manual click. It should be a params
                        // or removed in staging/prod.
                        // TODO: It seems that's better to wait a bit before
                        // stop recording things. A small delay before disposing
                        // the runner helps in this case.
                        return [4 /*yield*/, delay_1.default(5000)];
                    case 3:
                        // TODO: only use for dev purpose so far, used
                        // to allow a manual click. It should be a params
                        // or removed in staging/prod.
                        // TODO: It seems that's better to wait a bit before
                        // stop recording things. A small delay before disposing
                        // the runner helps in this case.
                        _a.sent();
                        // TODO: the name could be better here, and so far
                        // it's only used for retrieving the devtoolslogs.
                        return [4 /*yield*/, this.dispose()];
                    case 4:
                        // TODO: the name could be better here, and so far
                        // it's only used for retrieving the devtoolslogs.
                        _a.sent();
                        return [4 /*yield*/, this.runAudits()];
                    case 5:
                        auditResults = _a.sent();
                        auditResults.forEach(function (result) {
                            _this.audits.set(result.name, result);
                        });
                        return [4 /*yield*/, Output_1.default.generateReport(this.targetId, this.audits)];
                    case 6:
                        report = _a.sent();
                        return [2 /*return*/, this.callback(report)];
                }
            });
        });
    };
    return Runner;
}());
exports.default = Runner;
