/// <reference types="node" />
import { EventEmitter } from 'events';
import * as Protocol from '../types/tot';
import { Connection } from './Connection';
import DevtoolLogManager from './DevtoolLogManager';
import { TracerMessage } from './Tracer';
export default class Session extends EventEmitter {
    private callbacks;
    private connection;
    private lastId;
    private networkStatusMonitor;
    private monitoredUrl;
    devtoolLogManager: DevtoolLogManager;
    sessionId: string;
    targetId: string;
    targetVersion: number;
    constructor(connection: Connection, targetId: string, sessionId: string);
    dispose(): Promise<Protocol.Target.CloseTargetReturn>;
    setEvent(message: TracerMessage): void;
    setTargetId(id: string): void;
    setTargetVersion(version: number): void;
    onClosed(): void;
    onMessage(message: string): void;
    send<T>(method: string, params?: {
        [key: string]: any;
    }): Promise<T>;
    beginNetworkStatusMonitoring(startingUrl: string): void;
    getNetworkRecords(): any[];
    private callbackNetworkStatusMonitoring(redirectRequest);
    endNetworkStatusMonitoring(): string;
}
