"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Package.
var debug = require("debug");
// Code.
var debugVerbose = debug('di:verbose:taskQueue');
var debugWarn = debug('di:warn:taskQueue');
var TaskQueue = /** @class */ (function () {
    function TaskQueue() {
        this.chain = Promise.resolve();
    }
    TaskQueue.prototype.postTask = function (task) {
        debugVerbose("postTask");
        var result = this.chain.then(task);
        this.chain = result.catch(function (err) {
            debugWarn("postTask chain error:", err);
        });
        return result;
    };
    return TaskQueue;
}());
exports.TaskQueue = TaskQueue;
