"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Code.
var getExceptionMessage = function (exceptionDetails) {
    if (exceptionDetails.exception)
        return exceptionDetails.exception.description;
    var message = exceptionDetails.text;
    if (exceptionDetails.stackTrace) {
        for (var _i = 0, _a = exceptionDetails.stackTrace.callFrames; _i < _a.length; _i++) {
            var callframe = _a[_i];
            var location_1 = callframe.url +
                ':' +
                callframe.lineNumber +
                ':' +
                callframe.columnNumber;
            var functionName = callframe.functionName || '<anonymous>';
            message += "\n    at " + functionName + " (" + location_1 + ")";
        }
    }
    return message;
};
exports.default = getExceptionMessage;
